mbedtls/tests/scripts/all.sh

269 lines
6.9 KiB
Bash
Raw Normal View History

#!/bin/sh
# Run all available tests (mostly).
#
# Warning: includes various build modes, so it will mess with the current
# CMake configuration. After this script is run, the CMake cache is lost and
# CMake is not initialised any more!
2014-03-27 13:44:04 +00:00
#
2015-01-26 14:03:56 +00:00
# Assumes gcc and clang (recent enough for using ASan with gcc and MemSan with
# clang, or valgrind) are available, as well as cmake and a "good" find.
# Abort on errors (and uninitiliased variables)
set -eu
if [ -d library -a -d include -a -d tests ]; then :; else
2015-01-22 16:43:54 +00:00
echo "Must be run from mbed TLS root" >&2
exit 1
fi
2015-03-09 17:05:11 +00:00
CONFIG_H='include/mbedtls/config.h'
2014-07-12 02:00:00 +00:00
CONFIG_BAK="$CONFIG_H.bak"
MEMORY=0
while [ $# -gt 0 ]; do
case "$1" in
-m*)
2015-01-26 14:03:56 +00:00
MEMORY=${1#-m}
;;
*)
echo "Unknown argument: '$1'" >&2
echo "Use the source, Luke!" >&2
exit 1
;;
esac
shift
done
# remove built files as well as the cmake cache/config
cleanup()
{
make clean
2014-07-12 02:00:00 +00:00
2014-12-11 09:33:43 +00:00
find . -iname '*cmake*' -not -name CMakeLists.txt -exec rm -rf {} \+
2015-03-09 17:05:11 +00:00
rm -f include/Makefile include/mbedtls/Makefile programs/*/Makefile
git update-index --no-skip-worktree Makefile library/Makefile programs/Makefile tests/Makefile
git checkout -- Makefile library/Makefile programs/Makefile tests/Makefile
2014-07-12 02:00:00 +00:00
if [ -f "$CONFIG_BAK" ]; then
mv "$CONFIG_BAK" "$CONFIG_H"
fi
}
2014-07-12 02:00:00 +00:00
trap cleanup INT TERM HUP
2014-03-27 13:44:04 +00:00
msg()
{
echo ""
echo "******************************************************************"
echo "* $1 "
2015-01-26 14:03:56 +00:00
printf "* "; date
2014-03-27 13:44:04 +00:00
echo "******************************************************************"
}
2014-06-09 09:21:49 +00:00
# The test ordering tries to optimize for the following criteria:
# 1. Catch possible problems early, by running first tests that run quickly
2014-08-14 09:29:06 +00:00
# and/or are more likely to fail than others (eg I use Clang most of the
# time, so start with a GCC build).
2014-06-09 09:21:49 +00:00
# 2. Minimize total running time, by avoiding useless rebuilds
#
# Indicative running times are given for reference.
2014-03-27 13:44:04 +00:00
2014-11-20 16:32:33 +00:00
msg "test: recursion.pl" # < 1s
2015-04-09 15:19:23 +00:00
tests/scripts/recursion.pl library/*.c
2015-02-13 14:52:19 +00:00
msg "test: freshness of generated source files" # < 1s
tests/scripts/check-generated-files.sh
2015-04-09 15:19:23 +00:00
msg "test: doxygen markup outside doxygen blocks" # < 1s
tests/scripts/check-doxy-blocks.pl
2015-04-09 09:09:03 +00:00
msg "test/build: declared and exported names" # < 3s
cleanup
tests/scripts/check-names.sh
msg "build: cmake, gcc, ASan" # ~ 1 min 50s
cleanup
CC=gcc cmake -D CMAKE_BUILD_TYPE:String=Asan .
make
2014-06-09 09:21:49 +00:00
msg "test: main suites and selftest (ASan build)" # ~ 50s
make test
programs/test/selftest
2014-06-09 09:21:49 +00:00
msg "test: ssl-opt.sh (ASan build)" # ~ 1 min
2014-06-09 09:21:49 +00:00
cd tests
./ssl-opt.sh
cd ..
msg "test/build: ref-configs (ASan build)" # ~ 6 min 20s
2014-06-09 09:21:49 +00:00
tests/scripts/test-ref-configs.pl
# Most frequent issues are likely to be caught at this point
2014-06-09 09:21:49 +00:00
msg "build: with ASan (rebuild after ref-configs)" # ~ 1 min
make
msg "test: compat.sh (ASan build)" # ~ 6 min
cd tests
./compat.sh
cd ..
msg "build: cmake, full config, clang" # ~ 50s
2014-06-09 09:21:49 +00:00
cleanup
2014-07-12 02:00:00 +00:00
cp "$CONFIG_H" "$CONFIG_BAK"
scripts/config.pl full
scripts/config.pl unset MBEDTLS_MEMORY_BACKTRACE # too slow for tests
CC=clang cmake -D CMAKE_BUILD_TYPE:String=Check .
2014-06-09 09:21:49 +00:00
make
msg "test: main suites (full config)" # ~ 5s
2014-07-12 02:00:00 +00:00
make test
msg "test: ssl-opt.sh default (full config)" # ~ 1s
2014-07-12 02:00:00 +00:00
cd tests
./ssl-opt.sh -f Default
cd ..
msg "test: compat.sh RC4, DES & NULL (full config)" # ~ 2 min
2014-07-12 02:00:00 +00:00
cd tests
./compat.sh -e '3DES\|DES-CBC3' -f 'NULL\|DES\|RC4\|ARCFOUR'
2014-07-12 02:00:00 +00:00
cd ..
2014-11-20 12:29:53 +00:00
msg "test/build: curves.pl (gcc)" # ~ 5 min (?)
cleanup
cmake -D CMAKE_BUILD_TYPE:String=Debug .
tests/scripts/curves.pl
2015-03-13 14:33:16 +00:00
msg "build: Unix make, -Os (gcc)" # ~ 30s
2014-05-09 11:46:59 +00:00
cleanup
2015-03-13 14:33:16 +00:00
CC=gcc CFLAGS='-Werror -Os' make
2014-06-09 09:21:49 +00:00
# this is meant to cath missing #define mbedtls_printf etc
2015-02-17 15:46:45 +00:00
# disable fsio to catch some more missing #include <stdio.h>
2015-03-23 14:24:07 +00:00
msg "build: full config except platform/fsio, make, gcc" # ~ 30s
2015-02-13 13:56:55 +00:00
cleanup
cp "$CONFIG_H" "$CONFIG_BAK"
scripts/config.pl full
scripts/config.pl unset MBEDTLS_PLATFORM_C
scripts/config.pl unset MBEDTLS_PLATFORM_MEMORY
scripts/config.pl unset MBEDTLS_MEMORY_BUFFER_ALLOC_C
scripts/config.pl unset MBEDTLS_FS_IO
2015-03-13 14:33:16 +00:00
CC=gcc CFLAGS='-Werror -O0' make
2015-02-13 13:56:55 +00:00
2015-02-10 14:36:31 +00:00
if uname -a | grep -F x86_64 >/dev/null; then
msg "build: i386, make, gcc" # ~ 30s
cleanup
CC=gcc CFLAGS='-Werror -m32' make
fi # x86_64
if which arm-none-eabi-gcc >/dev/null; then
msg "build: arm-none-eabi-gcc, make" # ~ 10s
cleanup
cp "$CONFIG_H" "$CONFIG_BAK"
scripts/config.pl full
scripts/config.pl unset MBEDTLS_NET_C
scripts/config.pl unset MBEDTLS_TIMING_C
scripts/config.pl unset MBEDTLS_FS_IO
2015-02-10 14:36:31 +00:00
# following things are not in the default config
scripts/config.pl unset MBEDTLS_HAVEGE_C # depends on timing.c
scripts/config.pl unset MBEDTLS_THREADING_PTHREAD
scripts/config.pl unset MBEDTLS_THREADING_C
scripts/config.pl unset MBEDTLS_MEMORY_BACKTRACE # execinfo.h
scripts/config.pl unset MBEDTLS_MEMORY_BUFFER_ALLOC_C # calls exit
2015-02-10 14:36:31 +00:00
CC=arm-none-eabi-gcc CFLAGS=-Werror make lib
fi # arm-gcc
2015-02-10 16:38:54 +00:00
if which armcc >/dev/null; then
msg "build: armcc, make"
cleanup
cp "$CONFIG_H" "$CONFIG_BAK"
scripts/config.pl full
scripts/config.pl unset MBEDTLS_NET_C
scripts/config.pl unset MBEDTLS_TIMING_C
scripts/config.pl unset MBEDTLS_FS_IO
scripts/config.pl unset MBEDTLS_HAVE_TIME
2015-02-10 16:38:54 +00:00
# following things are not in the default config
scripts/config.pl unset MBEDTLS_DEPRECATED_WARNING
scripts/config.pl unset MBEDTLS_HAVEGE_C # depends on timing.c
scripts/config.pl unset MBEDTLS_THREADING_PTHREAD
scripts/config.pl unset MBEDTLS_THREADING_C
scripts/config.pl unset MBEDTLS_MEMORY_BACKTRACE # execinfo.h
scripts/config.pl unset MBEDTLS_MEMORY_BUFFER_ALLOC_C # calls exit
CC=armcc WARNING_CFLAGS= make lib 2> armcc.stderr
if [ -s armcc.stderr ]; then
cat armcc.stderr
exit 1;
fi
2015-02-10 16:38:54 +00:00
rm armcc.stderr
fi # armcc
2015-02-16 16:18:36 +00:00
if which i686-w64-mingw32-gcc >/dev/null; then
msg "build: cross-mingw64, make" # ~ 30s
cleanup
CC=i686-w64-mingw32-gcc AR=i686-w64-mingw32-ar CFLAGS=-Werror WINDOWS_BUILD=1 make
fi
2015-02-10 14:36:31 +00:00
# MemSan currently only available on Linux 64 bits
if uname -a | grep 'Linux.*x86_64' >/dev/null; then
2015-01-26 14:03:56 +00:00
msg "build: MSan (clang)" # ~ 1 min 20s
cleanup
cp "$CONFIG_H" "$CONFIG_BAK"
scripts/config.pl unset MBEDTLS_AESNI_C # memsan doesn't grok asm
scripts/config.pl set MBEDTLS_NO_PLATFORM_ENTROPY # memsan vs getrandom()
CC=clang cmake -D CMAKE_BUILD_TYPE:String=MemSan .
make
msg "test: main suites (MSan)" # ~ 10s
make test
2014-05-09 11:46:59 +00:00
msg "test: ssl-opt.sh (MSan)" # ~ 1 min
cd tests
./ssl-opt.sh
cd ..
2014-05-09 11:46:59 +00:00
# Optional part(s)
if [ "$MEMORY" -gt 0 ]; then
msg "test: compat.sh (MSan)" # ~ 6 min 20s
cd tests
./compat.sh
cd ..
2014-06-09 09:21:49 +00:00
fi
2015-01-26 14:03:56 +00:00
else # no MemSan
msg "build: Release (clang)"
cleanup
CC=clang cmake -D CMAKE_BUILD_TYPE:String=Release .
make
msg "test: main suites valgrind (Release)"
make test
# Optional part(s)
# Currently broken, programs don't seem to receive signals
# under valgrind on OS X
if [ "$MEMORY" -gt 0 ]; then
msg "test: ssl-opt.sh --memcheck (Release)"
cd tests
./ssl-opt.sh --memcheck
cd ..
fi
if [ "$MEMORY" -gt 1 ]; then
msg "test: compat.sh --memcheck (Release)"
cd tests
./compat.sh --memcheck
cd ..
fi
fi # MemSan
msg "Done, cleaning up"
cleanup